/******************************************************************************/
/*									      */
/* [PSXg[ANZXvOC]					      */
/*									      */
/*	FILE NAME	: Plugin.c   					      */
/*	FUNCTION	: WSTRANZX (CD-ROMp)			      */
/*									      */
/*	FUNCTIONS		| an outline				      */
/*    --------------------------+-------------------------------------------- */
/*	PsrQueryPlugin()	| vOC̎擾			      */
/*	PsrIsSupportCDBegin()	| CDT|[g Jn		      */
/*	PsrIsSupportCDEnd()	| CDT|[g I		      */
/*	PsrIsSupportCDSector()	| CDT|[g ZN^ʒm		      */
/*	PsrIsSupportCDResult()	| CDT|[g ʎ擾		      */
/*	PsrGetStrDataInfo()	| Xg[f[^̎擾		      */
/*	PsrOpenCD()		| CDXg[̃I[v		      */
/*	PsrClose()		| Xg[f[^̃N[Y		      */
/*	PsrRead()		| Xg[f[^̓ǂݎ		      */
/*	PsrSeek()		| ǂݎʒu̐ݒ			      */
/*									      */
/*	HISTORY		| Comment				| Name	      */
/*    ------------------+---------------------------------------+------------ */
/*	2000.06.16	| VK쐬				| ӂ      */
/*	2000.06.27	| CD-DAgbN܂CDɂΉ	1.01	| ӂ      */
/*	2000.06.27	| CD-DAgbN̓XLbv	1.01	| ӂ      */
/*	2000.06.27	| _~[ZN^̔Fǉ	1.01	| ӂ      */
/*	2000.06.30	| PʃZN^̕sǂ̑΍	1.01	| ӂ      */
/*	2000.07.03	| _~[ZN^F̋	1.02	| ӂ      */
/*	2000.07.06	| BSwb_`FbN (FF7Ή)	1.03	| ӂ      */
/*	2000.07.11	| PSRPLUGIN\̂̕ύX		1.10	| ӂ      */
/*	2000.07.12	| CD͒fp̒ǉ	1.10	| ӂ      */
/*	2000.07.12	| TvO[g̔	1.10	| ӂ      */
/*	2000.07.15	| t[[gF		1.11	| ӂ      */
/*	2000.07.16	| I[fBI		1.11	| ӂ      */
/*	2000.07.19	| t[[g(0.5step)	1.12	| ӂ      */
/*	2000.07.20	| STRI[苭		1.13	| ӂ      */
/*	2000.07.23	| 0(b΍)		1.14	| ӂ      */
/*	2000.08.03	| σt[[g΍	1.20	| ӂ      */
/*	2000.08.08	| F΍			1.21	| ӂ      */
/*	2000.08.10	| F΍ (2)		1.22	| ӂ      */
/*	2000.08.26	| CDǂݎ葬xݒ		1.23	| ӂ      */
/*	2000.10.28	| vOCdlύX		1.30	| ӂ      */
/*	2000.11.25	| i[`O鏈	1.31	| ӂ      */
/*	2000.12.03	| IKI`̃T|[g		1.31	| ӂ      */
/*									      */
/*			(C) Copyright ӂ 2000. All rights reserved.       */
/******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <Windows.h>

#include "CdAccess.h"
#include "PSRP.h"


#define _NumAUDIOBUFF		8
#define _MaxSEARCH		24
//#define _SpinSPEED		-1
#define _SpinSPEED		8


typedef struct {	// ZN^[\ ----------------------------------------
	BYTE		abSync[12];		// CD-ROM XA 
	BYTE		abHeader[4];		// CD-ROM XA wb_[
	BYTE		abSubHeader[8];		// CD-ROM XA TuEwb_[
						//  [01014280]x2 or [01016400]x2
	USHORT		usStatus;		// 0110 xxxx xxxx VVVV  ex:6001
						//	x : Reserved for system
						//	V : Version
	USHORT		usDataType;		// S--- ---- ---- ----	ex:8001
						//  S : 1=system-defained format
						//      0=user-defained format
	USHORT		usSectorNo;		// ZN^[ԍ	0`
	USHORT		usNumSector;		// ZN^[ / t[
	ULONG		ulFrameNo;		// t[ԍ	1`
	ULONG		ulLength;		// t[̃f[^
	USHORT		usWidth;		// C[W
	USHORT		usHeight;		// C[W
	ULONG		ulMovieHeadM;		// Reserved for system
	ULONG		ulMovieHeadV;		// Reserved for system
	ULONG		ulReserved;		// 0000 fixed
	USHORT		ausMovie[0x3F0];
	BYTE		abEdc[4];		// CD-ROM XA EDC
	BYTE		abEcc[276];		// CD-ROM XA ECC
} _TSECTOR, *_PTSECTOR;


typedef struct {	// Xg[ --------------------------------------
	DWORD		dwBeginNo;	// f[^JnZN^ԍ
	DWORD		dwLastMovieNo;	// Ō̓ZN^ԍ
	DWORD		dwFastAudioNo;	// ŏ̉ZN^ԍ
	DWORD		dwLastAudioNo;	// Ō̉ZN^ԍ

	BYTE		abAudioSH[4];	// ZN^̃Tuwb_
	DWORD		nStepAudio;	// ZN^̊Ԋu
	DWORD		nNumAudio;	// ZN^

	DWORD		nNumFrame;	// t[
	SIZE		szFrame;	// t[TCY
	DWORD		nSyncAudio;	// AZN^
	DWORD		nSyncFrame;	// At[
	DWORD		dwSize;		// f[^TCY			1.30
	USHORT		usDataType;	// ̃f[^^Cv		1.31

	WORD		wMinFrame;	// ŏt[ZN^
	WORD		wMaxFrame;	// őt[ZN^
} _TSTREAM, *_PTSTREAM;


typedef struct {	// Xg[Tnh̓e ------------------------
	BOOL		fFindout;	// tO
	DWORD		dwPreBeginNo;	// Õt[̊JnZN^ԍ
	DWORD		nNumAudio;	// dwPreBeginNõI[fBIZN^
	INT		iBuffer;	// Xg[obt@
	INT		iNum;		// Xg[
	_PTSTREAM	pstr;		// Xg[Q
} _TFIND, *_PTFIND;


typedef struct {	// Xg[nh̓e ----------------------------
	HANDLE		hCdrom;		// CD-ROMnh
	PSRSTREAMINFO	str;		// Xg[f[^
	DWORD		nStepAudio;	// I[fBIZN^Ԋu
	_PTSECTOR	apaudio[_NumAUDIOBUFF];	// ޔI[fBIZN^
} _THANDLE, *_PTHANDLE;


enum { _TypeUNKNOW, _TypeDUMMY, _TypeAUDIO, _TypeMOVIE };



//****--------------------------------------------------------------------------
//****	_psrGetFrameRate() : t[[g̎擾
//****--------------------------------------------------------------------------

static WORD	_strGetFrameRate(SIZE szFrame, DWORD nMinSect, DWORD nMaxSect) {
	DWORD		nMBlock, nReso, nLength;
	WORD		wReso, wLength;


	nMBlock	= ((szFrame.cx + 15) / 16) * ((szFrame.cy + 15) / 16);
	nReso	= 90000 / nMBlock;
	if(nReso < 150)		wReso = 75;
	else if(nReso < 300)	wReso = 150;
	else if(nReso < 600)	wReso = 300;
	else 			wReso = 600;

	nLength	= (nMinSect + nMaxSect) * (0x7e0 / 2);
	if(nLength > 20 * 1024)		wLength = 75;
	else if(nLength > 10 * 1024)	wLength = 150;
	else if(nLength >  5 * 1024)	wLength = 300;
	else				wLength = 600;

	return min(wReso, wLength);
}

/******************************************************************************/
/*									      */
/*	PsrQueryPlugin() : vOC̎擾				      */
/*									      */
/******************************************************************************/

CEXPORT	VOID	PsrQueryPlugin(
	LPPSRPLUGIN	lpPlugin)	// vOC擾obt@AhX
{
	strcpy(lpPlugin->aName,      "STR CD-ROM");
	strcpy(lpPlugin->aCopyright, "Copyright (c) Fyiro 2000.");
	lpPlugin->usVersion	     = 131;
	lpPlugin->usIsSupportVersion = 102;
	lpPlugin->usSystemVersion    = PSR_SYSTEMVERSION;
	strcpy(lpPlugin->aSiteName, "Fyiro's Garage");		// 1.30
	strcpy(lpPlugin->aSiteUrl, "http://homepage2.nifty.com/~mkb/");	// 1.30
}



/******************************************************************************/
/*									      */
/*	PsrIsSupportCDBegin() : CDT|[g Jn			      */
/*									      */
/******************************************************************************/

CEXPORT HANDLE	PsrIsSupportCDBegin(
	INT		iNumToc,	// TOC̐
	LPTOCENTRY	lptoc)		// TOC
{
	_PTFIND		pfind;
	INT		i;


			// DAgbN݂̂CD͏ΏۊO! ---------------------
	for(i=0; i<iNumToc; i++) {
		if(lptoc[i].bAdr & 0x04)	break;
	}
	if(i == iNumToc)	return NULL;

	if(!(pfind = malloc(sizeof(_TFIND))))	return NULL;

			// nh̍쐬Əݒ ----------------------------
	pfind->fFindout	= FALSE;
	pfind->iBuffer	= 10;
	pfind->iNum	= 0;
	pfind->pstr	= malloc(sizeof(_TSTREAM) * pfind->iBuffer);
	if(!pfind->pstr) {
		free(pfind);
		return NULL;
	}
	return pfind;
}



/******************************************************************************/
/*									      */
/*	PsrIsSupportCDEnd() : CDT|[g I			      */
/*									      */
/******************************************************************************/

CEXPORT	VOID	PsrIsSupportCDEnd(
	HANDLE		hIsCD)		// CDT|[gnh
{
	_PTFIND		pfind;


	if(!(pfind = hIsCD))	return;
	free(pfind->pstr);
	free(pfind);
}

/******************************************************************************/
/*									      */
/*	PsrIsSupportCDSector() : CDT|[g ZN^ʒm		      */
/*									      */
/******************************************************************************/

CEXPORT	BOOL	PsrIsSupportCDSector(
	HANDLE		hIsCD,		// CDT|[gnh
	TOCENTRY	toc,		// TOC
	DWORD		nSector,	// ZN^ԍ
	PVOID		pvSector)	// ZN^
{
	_PTFIND		pfind;
	_PTSECTOR	psector;
	_PTSTREAM	pstr;
	BOOL		fBegin;
	INT		iType, i;
	WORD		wNum;
	DWORD		dwLastSector;


	if(!(pfind = hIsCD))	return FALSE;
	if(!(toc.bAdr & 0x04))	return FALSE;		// CD-DA
	if(!(psector = pvSector)) {
		if(pfind->fFindout) {
			pfind->fFindout = FALSE;
			pstr = &pfind->pstr[pfind->iNum - 1];
			if((pstr->nNumFrame == 1) ||
			   (pstr->dwFastAudioNo && !pstr->nStepAudio)) {
				pfind->iNum --;
			}
		}
		return FALSE;
	}

			// Xg[̃ZN^ ? ------------------------------
	iType = _TypeUNKNOW;
	if((psector->abSubHeader[2] & 0x64) == 0x64) {
		iType = _TypeAUDIO;
	} else {
		if((psector->usStatus & 0x00f0) == 0x0060 &&
		   (psector->usDataType & 0x8000) &&
		   psector->ulFrameNo &&
		   psector->usNumSector <= 20 &&
		   psector->usNumSector && !psector->ulReserved) {
			iType = _TypeMOVIE;
		}
	}

	fBegin = FALSE;	// 擪ZN^ ? --------------------------------------
	if(iType == _TypeMOVIE) {
		if(!psector->usSectorNo && psector->ulFrameNo == 1) {
			for(i=0; i<_MaxSEARCH; i++) {
				if(psector->ausMovie[i+1] == 0x3800)	break;
			}
			if(psector->ausMovie[i+1] == 0x3800 &&	// MAGIC
			   (psector->ausMovie[i+3] <= 3 ||	// FLC or VLC
			   (psector->ausMovie[i+2] == psector->usWidth &&
			    psector->ausMovie[i+3] == psector->usHeight)))
				fBegin = TRUE;
			else	iType = _TypeUNKNOW;
		}
	}
	if(!pfind->fFindout && !fBegin)	iType = _TypeUNKNOW;
	if(iType == _TypeAUDIO && pfind->fFindout) {
		pstr = &pfind->pstr[pfind->iNum - 1];
		if(pstr->nNumAudio &&
		   memcmp(pstr->abAudioSH, psector->abSubHeader, 4) != 0) {
			iType = _TypeUNKNOW;
		}
	}
	if(iType == _TypeUNKNOW) {
		if(!psector->usStatus)	iType = _TypeDUMMY;
	}
	if(iType == _TypeDUMMY)	return TRUE;

// Xg[Ăꍇ **********************************************

	if(pfind->fFindout) {
		pstr = &pfind->pstr[pfind->iNum - 1];
		dwLastSector = max(pstr->dwLastMovieNo, pstr->dwLastAudioNo);

			// f[^̏I --------------------------------------
			//	1. Xg[̊JnZN^̏ꍇ ----------------
			//	2. ꂽʒũZN^̏ꍇ ------------
			//	3. Xg[łȂZN^̏ꍇ ----------------
		if(fBegin || nSector - dwLastSector > 32 || iType == _TypeUNKNOW) {
			pfind->fFindout = FALSE;
			if((pstr->nNumFrame == 1) ||
			   (pstr->dwFastAudioNo && !pstr->nStepAudio)) {
				pfind->iNum --;
			}
		}

			// ZN^ ------------------------------------------
		else if(iType == _TypeMOVIE) {
			if(pstr->usDataType != psector->usDataType) {	// 1.31
				pfind->fFindout = FALSE;		// 1.31
				pfind->iNum --;				// 1.31
				return TRUE;				// 1.31
			}						// 1.31

			pstr->dwLastMovieNo	= nSector;
			if(psector->usSectorNo == 0) {
				pstr->nNumFrame	= psector->ulFrameNo;
				pstr->szFrame.cx = max(pstr->szFrame.cx,
							psector->usWidth);
				pstr->szFrame.cy = max(pstr->szFrame.cy,
							psector->usHeight);

				wNum  = (WORD)(nSector - pfind->dwPreBeginNo);
				wNum -= (WORD)pfind->nNumAudio;
				pstr->wMinFrame = min(pstr->wMinFrame, wNum);
				pstr->wMaxFrame = max(pstr->wMaxFrame, wNum);
				pstr->dwSize	+= psector->ulLength;	// 1.30
				pfind->dwPreBeginNo	= nSector;
				pfind->nNumAudio	= 0;
			}
			if(pstr->nNumAudio &&
			   nSector - pstr->dwLastAudioNo < pstr->nStepAudio) {
				pstr->nSyncAudio = pstr->nNumAudio;
				pstr->nSyncFrame = pstr->nNumFrame;
			}
		}

		else {	// ZN^ ------------------------------------------
			if(!pstr->nNumAudio) {
				pstr->dwFastAudioNo = nSector;
				pstr->nStepAudio    = nSector - pstr->dwBeginNo;
				memcpy(pstr->abAudioSH, psector->abSubHeader, 4);
			}
			else if(pstr->nNumAudio == 1) {
				pstr->nStepAudio = nSector - pstr->dwFastAudioNo;
			}
			pstr->dwLastAudioNo = nSector;
			pstr->dwSize	+= 0x900;			// 1.30
			pstr->nNumAudio ++;
			pfind->nNumAudio ++;
		}

			// f[^̏I --------------------------------------
		if(psector->abSubHeader[2] == 0x89) {
			pstr = &pfind->pstr[pfind->iNum - 1];
			pfind->fFindout = FALSE;
			if((pstr->nNumFrame == 1) ||
			   (pstr->dwFastAudioNo && !pstr->nStepAudio)) {
				pfind->iNum --;
			}
		}
	}

// Xg[ĂȂꍇ ********************************************

			// Xg[! -----------------------------
	if(!pfind->fFindout && fBegin) {
		if(pfind->iBuffer == pfind->iNum) {
			pfind->iBuffer += 10;
			pstr = realloc(pfind->pstr,
					sizeof(_TSTREAM) * pfind->iBuffer);
			if(!pstr) {
				pfind->iBuffer -= 10;
				return TRUE;	// Ƃ肠I
			}
			pfind->pstr = pstr;
		}

		pstr = &pfind->pstr[pfind->iNum];
		pstr->dwBeginNo		= nSector;
		pstr->dwLastMovieNo	= nSector;
		pstr->dwFastAudioNo	= 0;
		pstr->dwLastAudioNo	= 0;
		pstr->nStepAudio	= 0;
		pstr->nNumAudio		= 0;
		pstr->nNumFrame		= 1;
		pstr->szFrame.cx	= psector->usWidth;
		pstr->szFrame.cy	= psector->usHeight;
		pstr->nSyncAudio	= 0;
		pstr->nSyncFrame	= 0;
		pstr->dwSize		= psector->ulLength;		// 1.30
		pstr->usDataType	= psector->usDataType;		// 1.31
		pstr->wMinFrame		= 0xffff;
		pstr->wMaxFrame		= 0;

		pfind->fFindout		= TRUE;
		pfind->dwPreBeginNo	= nSector;
		pfind->nNumAudio	= 0;
		pfind->iNum ++;
	}

	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrIsSupportCDResult() : CDT|[g ʎ擾		      */
/*									      */
/******************************************************************************/

CEXPORT	INT	PsrIsSupportCDResult(
	HANDLE		hIsCD,		// CDT|[gnh
	INT		iIndex,		// Xg[CfbNX
	LPPSRSTREAMINFO	lpStreamInfo)	// Xg[f[^
{
	_PTFIND		pfind;
	_PTSTREAM	pstr;
	DWORD		dwLast, nChannels, nSampleRate, nSample;
	DWORD		dwTime, dwAudio, dwMovie;
	WORD		wFps;


	if(!(pfind = hIsCD))		return 0;
	if(pfind->iNum <= iIndex)	return -1;
	if(!lpStreamInfo)		return pfind->iNum;

	pstr = &pfind->pstr[iIndex];

			// Xg[f[^bIɐݒ ------------------
	dwLast	= max(pstr->dwLastMovieNo, pstr->dwLastAudioNo);
	wFps	= _strGetFrameRate(pstr->szFrame,
				pstr->wMinFrame, pstr->wMaxFrame);
	lpStreamInfo->wTypeFlags	= PSR_STRTYPE_MOVIE;
	lpStreamInfo->wReserved		= 0;
	lpStreamInfo->nBeginSector	= pstr->dwBeginNo;
	lpStreamInfo->nNumSector	= (dwLast - pstr->dwBeginNo) + 1;
	lpStreamInfo->nNumFrame		= pstr->nNumFrame;
	lpStreamInfo->szFrame		= pstr->szFrame;
	lpStreamInfo->wFrameRate	= wFps;
	lpStreamInfo->wFormatTag	= 0;
	lpStreamInfo->wChannels		= 0;
	lpStreamInfo->wBitsPerSample	= 0;
	lpStreamInfo->nSamplesPerSec	= 0;
	lpStreamInfo->nPlayTime		= (pstr->nNumFrame * 10000) /
						lpStreamInfo->wFrameRate;
	lpStreamInfo->nDataSize		= pstr->dwSize;			// 1.30

			// I[fBIݒ --------------------------------
	if(pstr->nNumAudio) {
		nChannels   = (pstr->abAudioSH[3] & 0x01) ? 2 : 1;
		nSampleRate = (pstr->abAudioSH[3] & 0x04) ? 18900 : 37800;
		lpStreamInfo->wTypeFlags	|= PSR_STRTYPE_AUDIO;
		lpStreamInfo->wFormatTag	= WAVE_FORMAT_PCM;
		lpStreamInfo->wBitsPerSample	= 16;
		lpStreamInfo->wChannels		= (WORD)nChannels;
		lpStreamInfo->nSamplesPerSec	= nSampleRate;

			// I[fBIf[^Ƀt[[gvZ ----------
		nSample	= nChannels * (nSampleRate / 100);
		dwTime	= (pstr->nSyncAudio * 40320) / nSample;
		if(dwTime) wFps = (WORD)((pstr->nSyncFrame * 10000) / dwTime);

			// σt[[g̏ꍇc --------------------------
		if(abs((INT)lpStreamInfo->wFrameRate - (INT)wFps) > 20){
			if(pstr->wMaxFrame - pstr->wMinFrame > 3) {
				lpStreamInfo->wTypeFlags |= PSR_STRTYPE_VFRATE;
				lpStreamInfo->wFrameRate = _strGetFrameRate(
								pstr->szFrame,
								pstr->wMinFrame,
								pstr->wMinFrame);
			}

			// Œt[[g̏ꍇ ----------------------------
			else {
				lpStreamInfo->wFrameRate = ((wFps + 2) / 5) * 5;
			}
		}
		lpStreamInfo->wFrameRate = max(lpStreamInfo->wFrameRate, 50);

			// ĐԂ̍ČvZ ------------------------------------
		dwAudio = (pstr->nNumAudio * 40320) / nSample;
		dwMovie = (pstr->nNumFrame * 10000) / lpStreamInfo->wFrameRate;
		lpStreamInfo->nPlayTime	= max(dwAudio, dwMovie);
	}

	return pfind->iNum;
}

/******************************************************************************/
/*									      */
/*	PsrGetStrDataInfo() : Xg[f[^̎擾		      */
/*									      */
/******************************************************************************/

CEXPORT	BOOL	PsrGetStrDataInfo(
	INT		iDriveNo,	// hCuԍ
	DWORD		dwBegin,	// JnZN^ԍ
	DWORD		dwNumSector,	// ZN^
	LPPSRSTREAMINFO	lpStreamInfo)	// Xg[f[^
{
	HANDLE		hCdrom;
	_PTSECTOR	psector;
	SIZE		szFrame;
	DWORD		nNumAudio, nNumMovie, nNumFrame, nTimeAudio;
	DWORD		nSecCount, nMin, nMax, nChannels, nSampleRate;
	WORD		wRate;
	BYTE		bAudioSubH;


			// 擪nt[̃ZN^ǂݎĕKvȏW -
	hCdrom = CdReadOpen(iDriveNo, NULL, dwBegin, min(dwNumSector, 300), -1);
	if(!hCdrom)	return FALSE;

	nNumAudio = nNumMovie = nNumFrame = 0;
	while(psector = CdReadSector(hCdrom, NULL)) {
		if(psector->abSubHeader[2] == 0x64) {
			nNumAudio ++;
			bAudioSubH = psector->abSubHeader[3];
		}
		else if(psector->usStatus && psector->ulFrameNo > 30) {
			CdUnlockReadBuffer(hCdrom, psector);
			break;
		}
		else {
			nNumMovie ++;
			if(psector->usStatus && psector->usSectorNo == 0) {
				szFrame.cx = psector->usWidth;
				szFrame.cy = psector->usHeight;
				nNumFrame = psector->ulFrameNo;
			}
		}
		CdUnlockReadBuffer(hCdrom, psector);
	}
	CdReadClose(hCdrom);
	if(!nNumMovie)	return FALSE;

			// Xg[f[^쐬 ----------------------
	nSecCount = nNumAudio + nNumMovie;
	nMin	  = nNumMovie / nNumFrame;
	nMax	  = (nNumMovie + nNumFrame - 1) / nNumFrame;
	lpStreamInfo->wTypeFlags	= PSR_STRTYPE_MOVIE;
	lpStreamInfo->wReserved		= 0;
	lpStreamInfo->nBeginSector	= dwBegin;
	lpStreamInfo->nNumSector	= dwNumSector;
	lpStreamInfo->nNumFrame		= (dwNumSector * nNumFrame) / nSecCount;
	lpStreamInfo->szFrame		= szFrame;
	lpStreamInfo->wFrameRate	= _strGetFrameRate(szFrame, nMin, nMax);
	lpStreamInfo->wFormatTag	= 0;
	lpStreamInfo->wChannels		= 0;
	lpStreamInfo->wBitsPerSample	= 0;
	lpStreamInfo->nSamplesPerSec	= 0;

	if(nNumAudio) {
		nChannels   = (bAudioSubH & 0x01) ? 2 : 1;
		nSampleRate = (bAudioSubH & 0x04) ? 18900 : 37800;
		lpStreamInfo->wTypeFlags	|= PSR_STRTYPE_AUDIO;
		lpStreamInfo->wFormatTag	= WAVE_FORMAT_PCM;
		lpStreamInfo->wBitsPerSample	= 16;
		lpStreamInfo->wChannels		= (WORD)nChannels;
		lpStreamInfo->nSamplesPerSec	= nSampleRate;

			// t[[g␳ ----------------------------------
		nTimeAudio = (nNumAudio * 40320) /
					(nChannels * (nSampleRate / 100));
		wRate = (WORD)((nNumFrame * 10000) / nTimeAudio);
		if(abs((INT)lpStreamInfo->wFrameRate - (INT)wRate) > 20){
			lpStreamInfo->wFrameRate = ((wRate + 2) / 5) * 5;
		}
	}
	lpStreamInfo->nPlayTime = (lpStreamInfo->nNumFrame * 10000) /
						lpStreamInfo->wFrameRate;
	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrOpenCD() : CDXg[̃I[v				      */
/*									      */
/******************************************************************************/

CEXPORT HANDLE	PsrOpenCD(
	INT		iDriveNo,	// hCuԍ
	LPPSRSTREAMINFO	lpStreamInfo)	// Xg[f[^
{
	_PTHANDLE	phandle;
	_PTSECTOR	psector;
	HANDLE		hCdrom;
	DWORD		i, dwSec1, dwSec2;


			// CD-ROM̃I[v ------------------------------------
	hCdrom = CdReadOpen(iDriveNo, NULL,
				lpStreamInfo->nBeginSector,
				lpStreamInfo->nNumSector, _SpinSPEED);
	if(!hCdrom)	return NULL;

			// nh쐬 --------------------------------------
	if(!(phandle = malloc(sizeof(_THANDLE)))) {
		CdReadClose(hCdrom);
		return NULL;
	}
	phandle->hCdrom	= hCdrom;
	phandle->str	= *lpStreamInfo;
	for(i=0; i<_NumAUDIOBUFF; i++)	phandle->apaudio[i] = NULL;

			// I[fBIZN^Ԋu߂ ------------------------
	dwSec1 = dwSec2 = 0;
	if(lpStreamInfo->wTypeFlags & PSR_STRTYPE_AUDIO) {
		for(i=1; !dwSec1 || !dwSec2; i++) {
			if(!(psector = CdReadSector(hCdrom, NULL)))	break;
			if((psector->abSubHeader[2] & 0x64) == 0x64) {
				if(!dwSec1)	dwSec1 = i;
				else		dwSec2 = i;
			}
			CdUnlockReadBuffer(hCdrom, psector);
		}
		CdSetReadPointer(hCdrom, 0, FILE_BEGIN);
	}
	if(dwSec2)	phandle->nStepAudio = dwSec2 - dwSec1;
	else		phandle->nStepAudio = dwSec1;

	return phandle;
}

/******************************************************************************/
/*									      */
/*	PsrClose() : Xg[f[^̃N[Y				      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrClose(
	HANDLE		hStream)	// Xg[nh
{
	_PTHANDLE	phandle;


	phandle = hStream;
	if(phandle->hCdrom)	CdReadClose(phandle->hCdrom);
	free(phandle);
	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrRead() : Xg[f[^̓ǂݎ				      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrRead(
	HANDLE		hStream,	// Xg[nh
	LPPSRREADBUFF	lpBuffer)	// ǂݎobt@
{
	_PTHANDLE	phandle;
	_PTSECTOR	psector;
	PBYTE		pbBuff;
	INT		iLength, iSize, i, iPos;
	BOOL		fComp;


	phandle = hStream;
	memset(lpBuffer, 0, sizeof(PSRREADBUFF) - PSR_FRAMEBUFFER);

			// ޔI[fBIobt@̓eݒ ------------------
	pbBuff	= lpBuffer->abData;
	for(i=0; i<_NumAUDIOBUFF; i++) {
		if(!phandle->apaudio[i])	break;
		memcpy(pbBuff, &phandle->apaudio[i]->usStatus, 0x900);
		CdUnlockReadBuffer(phandle->hCdrom, phandle->apaudio[i]);
		phandle->apaudio[i] = NULL;
		lpBuffer->nLength += 0x900;
		pbBuff += 0x900;
	}
	if(lpBuffer->nLength)	return TRUE;

	iLength = 0;	// CDǂݍŐݒ --------------------------------
	fComp	= FALSE;
	while(!fComp) {
		if(!(psector = CdReadSector(phandle->hCdrom, NULL)))	break;

				// f[^ - - - - - - - - - - - - - - - - -
		if((psector->abSubHeader[2] & 0x64) == 0x64) {
			if(!lpBuffer->nFrameNo) {
				lpBuffer->nLength	= 0x900;
				memcpy(lpBuffer->abData, &psector->usStatus, 0x900);
				fComp = TRUE;
			}
			else {
				for(i=0; i<_NumAUDIOBUFF; i++) {
					if(!phandle->apaudio[i]) {
						phandle->apaudio[i] = psector;
						break;
					}
				}
				if(i != _NumAUDIOBUFF)	continue;
			}
		}

				// ff[^ - - - - - - - - - - - - - - - - -
		else if(psector->usStatus && psector->ulFrameNo) {

			iPos = 0;	// 擪ZN^ - - - - - - - - - - - - -
			if(!psector->usSectorNo) {
				lpBuffer->nFrameNo	= psector->ulFrameNo;
				lpBuffer->szFrame.cx	= psector->usWidth;
				lpBuffer->szFrame.cy	= psector->usHeight;
				iLength	= (INT)psector->ulLength;
				pbBuff	= lpBuffer->abData;
				for(iPos=0; iPos<_MaxSEARCH; iPos++) {
					if(psector->ausMovie[iPos+1] == 0x3800)	break;
				}
			}

			if(iLength) {	// C[Wf[^̃Rs[ - - - - - - -
				iSize = sizeof(psector->ausMovie) -
						(sizeof(USHORT) * iPos);
				iSize = min(iSize, iLength);
				memcpy(pbBuff, &psector->ausMovie[iPos], iSize);
				pbBuff	+= iSize;
				iLength	-= iSize;
				lpBuffer->nLength += iSize;
			}

					// ŏIZN^ - - - - - - - - - - - - -
			if(psector->usSectorNo == psector->usNumSector - 1) {
				if(lpBuffer->nFrameNo) {
					fComp = TRUE;
					if(phandle->str.wTypeFlags & PSR_STRTYPE_VFRATE) {
						lpBuffer->wFrameRate =
							_strGetFrameRate(
								lpBuffer->szFrame,
								psector->usNumSector-1,
								psector->usNumSector);
					}
				}
			}
		}
		CdUnlockReadBuffer(phandle->hCdrom, psector);
	}
	return fComp;
}

/******************************************************************************/
/*									      */
/*	PsrSeek() : ǂݎʒu̐ݒ					      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrSeek(
	HANDLE		hStream,	// Xg[nh
	DWORD		dwPosition)	// ǂݎʒu		1/1000bP
{
	_PTHANDLE	phandle;
	DWORD		nFrame, nSector;
	INT		i;
	double		dPos;


	phandle = hStream;
	for(i=0; i<_NumAUDIOBUFF; i++) {
		if(phandle->apaudio[i]) {
			CdUnlockReadBuffer(phandle->hCdrom, phandle->apaudio[i]);
			phandle->apaudio[i] = NULL;
		}
	}

			// ff[^ZN^ʒuZo ----------------------
	if(!(phandle->str.wTypeFlags & PSR_STRTYPE_AUDIO)) {
		nFrame	= (dwPosition * phandle->str.wFrameRate) / 10000;
		nSector	= (nFrame * phandle->str.nNumSector) / phandle->str.nNumFrame;
	}

	else {		// f[^ZN^ʒuZo ----------------------
		dPos = (double)(phandle->str.nSamplesPerSec / 100);
		dPos *= (double)(dwPosition * phandle->nStepAudio);
		dPos /= (double)(40320 / (DWORD)phandle->str.wChannels);
		nSector = (DWORD)dPos;
	}
	nSector = min(nSector, phandle->str.nNumSector);

	if(CdSetReadPointer(phandle->hCdrom, (LONG)nSector, FILE_BEGIN) == 0xffffffff) {
		return FALSE;
	}

	return TRUE;
}
